#include <stddef.h>
#include <sys/syscall.h>
#include <unistd.h>

int liballoc_lock()
{
    return 0;
}

int liballoc_unlock()
{
    return 0;
}

void* liballoc_alloc(size_t size)
{
    unsigned long int result = (unsigned long int)syscall(SYS_mmap, NULL, size * 4096, 1);
    return (void*)result;
}

int liballoc_free(void* address, size_t size)
{
    int result = syscall(SYS_munmap, address, size * 4096);
    if (result < 0) return 1;
    else
        return 0;
}